package borders.diagram.part;

import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import borders.Border;
import borders.Diagram;
import borders.diagram.edit.parts.DiagramEditPart;
import borders.diagram.edit.parts.LineBorderEditPart;

/**
* @generated
*/
public class BordersDiagramUpdater {

	/**
	* @generated
	*/
	public static List<BordersNodeDescriptor> getSemanticChildren(View view) {
		switch (BordersVisualIDRegistry.getVisualID(view)) {
		case DiagramEditPart.VISUAL_ID:
			return getDiagram_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	* @generated
	*/
	public static List<BordersNodeDescriptor> getDiagram_1000SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Diagram modelElement = (Diagram) view.getElement();
		LinkedList<BordersNodeDescriptor> result = new LinkedList<BordersNodeDescriptor>();
		for (Iterator<?> it = modelElement.getBorders().iterator(); it.hasNext();) {
			Border childElement = (Border) it.next();
			int visualID = BordersVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == LineBorderEditPart.VISUAL_ID) {
				result.add(new BordersNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<BordersLinkDescriptor> getContainedLinks(View view) {
		switch (BordersVisualIDRegistry.getVisualID(view)) {
		case DiagramEditPart.VISUAL_ID:
			return getDiagram_1000ContainedLinks(view);
		case LineBorderEditPart.VISUAL_ID:
			return getLineBorder_2001ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	* @generated
	*/
	public static List<BordersLinkDescriptor> getIncomingLinks(View view) {
		switch (BordersVisualIDRegistry.getVisualID(view)) {
		case LineBorderEditPart.VISUAL_ID:
			return getLineBorder_2001IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	* @generated
	*/
	public static List<BordersLinkDescriptor> getOutgoingLinks(View view) {
		switch (BordersVisualIDRegistry.getVisualID(view)) {
		case LineBorderEditPart.VISUAL_ID:
			return getLineBorder_2001OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<BordersLinkDescriptor> getDiagram_1000ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<BordersLinkDescriptor> getLineBorder_2001ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<BordersLinkDescriptor> getLineBorder_2001IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<BordersLinkDescriptor> getLineBorder_2001OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	* @generated
	*/
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {

		/**
		* @generated
		*/
		@Override
		public List<BordersNodeDescriptor> getSemanticChildren(View view) {
			return BordersDiagramUpdater.getSemanticChildren(view);
		}

		/**
		* @generated
		*/
		@Override
		public List<BordersLinkDescriptor> getContainedLinks(View view) {
			return BordersDiagramUpdater.getContainedLinks(view);
		}

		/**
		* @generated
		*/
		@Override
		public List<BordersLinkDescriptor> getIncomingLinks(View view) {
			return BordersDiagramUpdater.getIncomingLinks(view);
		}

		/**
		* @generated
		*/
		@Override
		public List<BordersLinkDescriptor> getOutgoingLinks(View view) {
			return BordersDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
